indexing

	description: "eposix's mime parser."

	standards: "Based on RFC 822, 2045 and 2047."

	implementation:
		"1. Not all recognized field names are parsed.%
		%   Should be easy to expand if you wish to do real message parsing.%
		%   That is not yet the case, everything about MIME messages%
		%   must be defined here and compiled in.%
		%2. Fields to add: Content-Type-Encoding; Content-Description%
		%3. What if no header, just empty line and body? Parsed ok?"

	known_bugs:
		"1. Dates with invalid time-zone get time-zone +0000."

	author: "Berend de Boer"
	date: "$Date: $"
	revision: "$Revision: $"

class

	EPX_MIME_PARSER


inherit

	EPX_MIME_SCANNER
		rename
			make as make_scanner
		redefine
			wrap
		end

	YY_OLD_PARSER_SKELETON [ANY]
		rename
			parse as do_parse
		redefine
			make,
			report_error
		end

	EPX_MIME_PARAMETER_NAMES
		export
			{NONE} all
		end

	STDC_CURRENT_PROCESS
		rename
			abort as abort_process
		export
			{NONE} all
		end


creation

	make,
	make_from_file,
	make_from_stream,
	make_from_file_descriptor



feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate ?= yytranslate_template
			yyr1 ?= yyr1_template
			yytypes1 ?= yytypes1_template
			yytypes2 ?= yytypes2_template
			yydefact ?= yydefact_template
			yydefgoto ?= yydefgoto_template
			yypact ?= yypact_template
			yypgoto ?= yypgoto_template
			yytable ?= yytable_template
			yycheck ?= yycheck_template
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval4: EPX_MIME_FIELD
			yyval6: EPX_MIME_FIELD_CONTENT_DISPOSITION
			yyval7: EPX_MIME_FIELD_CONTENT_LENGTH
			yyval8: EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING
			yyval9: EPX_MIME_FIELD_CONTENT_TYPE
			yyval10: EPX_MIME_FIELD_DATE
			yyval11: EPX_MIME_FIELD_IF_MODIFIED_SINCE
			yyval12: EPX_MIME_FIELD_MESSAGE_ID
			yyval13: EPX_MIME_FIELD_MIME_VERSION
			yyval2: STRING
			yyval14: STDC_TIME
			yyval16: INTEGER
			yyval15: EPX_MIME_PARAMETER
			yyval5: EPX_MIME_UNSTRUCTURED_FIELD
		do
			inspect yy_act
when 1 then
--|#line 151 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 151")
end

			yyval := yyval_default;
accept 

if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 2 then
--|#line 152 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 152")
end

			yyval := yyval_default;
accept 

if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 3 then
--|#line 157 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 157")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 4 then
--|#line 158 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 158")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 5 then
--|#line 163 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 163")
end


if yytype4 (yyvs.item (yyvsp - 1)) /= Void then part.header.add_non_unique_field (yytype4 (yyvs.item (yyvsp - 1))) end 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 6 then
--|#line 165 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 165")
end


part.header.add_non_unique_field (yytype5 (yyvs.item (yyvsp - 1))) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 7 then
--|#line 167 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 167")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 8 then
--|#line 167 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 167")
end


reset_start_condition 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 9 then
--|#line 173 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 173")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 10 then
--|#line 174 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 174")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 11 then
--|#line 175 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 175")
end


yyval4 := yytype6 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 12 then
--|#line 177 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 177")
end


yyval4 := yytype7 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 13 then
--|#line 179 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 179")
end


yyval4 := yytype8 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 14 then
--|#line 181 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 181")
end


yyval4 := yytype9 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 15 then
--|#line 183 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 183")
end


yyval4 := yytype10 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 16 then
--|#line 185 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 185")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 17 then
--|#line 186 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 186")
end


yyval4 := yytype11 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 18 then
--|#line 188 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 188")
end


yyval4 := yytype12 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 19 then
--|#line 190 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 190")
end


yyval4 := yytype13 (yyvs.item (yyvsp)) 
			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 20 then
--|#line 192 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 192")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 21 then
--|#line 193 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 193")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 22 then
--|#line 194 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 194")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 23 then
--|#line 195 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 195")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 24 then
--|#line 196 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 196")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 25 then
--|#line 197 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 197")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 26 then
--|#line 198 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 198")
end



			yyval := yyval4
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 27 then
--|#line 205 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 205")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 28 then
--|#line 206 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 206")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 29 then
--|#line 210 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 210")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 30 then
--|#line 211 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 211")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 31 then
--|#line 215 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 215")
end


			yyval6 := my_content_disposition
			current_parameter_field := Void
		
			yyval := yyval6
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp := yyvsp - 4
	yyvs.put (yyval, yyvsp)
end
when 32 then
--|#line 215 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 215")
end


			create my_content_disposition.make (yytype2 (yyvs.item (yyvsp)))
			current_parameter_field := my_content_disposition
			start_parameter
		
			yyval := yyval6
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 33 then
--|#line 230 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 230")
end


			create yyval7.make (yytype16 (yyvs.item (yyvsp)))
		
			yyval := yyval7
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 34 then
--|#line 238 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 238")
end


			create yyval8.make (yytype2 (yyvs.item (yyvsp)))
		
			yyval := yyval8
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 35 then
--|#line 246 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 246")
end


			yyval9 := my_content_type
			current_parameter_field := Void
		
			yyval := yyval9
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp := yyvsp - 6
	yyvs.put (yyval, yyvsp)
end
when 36 then
--|#line 246 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 246")
end


			create my_content_type.make (yytype2 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp)))
			current_parameter_field := my_content_type
			start_parameter
		
			yyval := yyval9
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 37 then
--|#line 262 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 262")
end


			if yytype14 (yyvs.item (yyvsp)) /= Void then
				create yyval10.make (yytype14 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval10
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 38 then
--|#line 262 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 262")
end


expect_date 
			yyval := yyval10
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 39 then
--|#line 274 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 274")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 40 then
--|#line 278 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 278")
end


			yyval11 := my_if_modified_since
			current_parameter_field := Void
		
			yyval := yyval11
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp := yyvsp - 5
	yyvs.put (yyval, yyvsp)
end
when 41 then
--|#line 278 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 278")
end


expect_date 
			yyval := yyval11
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 42 then
--|#line 278 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 278")
end


			create my_if_modified_since.make (yytype14 (yyvs.item (yyvsp)))
			current_parameter_field := my_if_modified_since
			start_parameter
		
			yyval := yyval11
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 43 then
--|#line 294 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 294")
end


create yyval12.make (yytype2 (yyvs.item (yyvsp))) 
			yyval := yyval12
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 44 then
--|#line 299 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 299")
end


create yyval13.make (yytype16 (yyvs.item (yyvsp - 2)), yytype16 (yyvs.item (yyvsp))) 
			yyval := yyval13
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp := yyvsp - 4
	yyvs.put (yyval, yyvsp)
end
when 45 then
--|#line 305 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 305")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 11
	yyvsp := yyvsp - 10
	yyvs.put (yyval, yyvsp)
end
when 46 then
--|#line 305 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 305")
end

			yyval := yyval_default;
expect_date 

if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 47 then
--|#line 316 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 316")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 48 then
--|#line 320 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 320")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 49 then
--|#line 324 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 324")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 50 then
--|#line 328 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 328")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 51 then
--|#line 332 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 332")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 52 then
--|#line 337 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 337")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 53 then
--|#line 338 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 338")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 54 then
--|#line 344 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 344")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 55 then
--|#line 345 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 345")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 56 then
--|#line 350 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 350")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 57 then
--|#line 351 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 351")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 58 then
--|#line 352 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 352")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 59 then
--|#line 356 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 356")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 60 then
--|#line 357 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 357")
end

			yyval := yyval_default;
yyval := yytype2 (yyvs.item (yyvsp)) 

if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 61 then
--|#line 362 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 362")
end


		create yyval2.make_from_string (yytype2 (yyvs.item (yyvsp - 2)))
		yyval2.append_character ('@')
		yyval2.append_string (yytype2 (yyvs.item (yyvsp - 2)))
		
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 62 then
--|#line 371 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 371")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 63 then
--|#line 372 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 372")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 64 then
--|#line 376 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 376")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 65 then
--|#line 381 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 381")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 66 then
--|#line 387 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 387")
end


yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 67 then
--|#line 389 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 389")
end


yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 68 then
--|#line 391 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 391")
end


yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 69 then
--|#line 396 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 396")
end


			if my_date.is_two_digit_year (yytype3 (yyvs.item (yyvsp)).item) then
				my_year := my_date.four_digit_year (yytype3 (yyvs.item (yyvsp)).item)
			else
				my_year := yytype3 (yyvs.item (yyvsp)).item
			end
			if
				my_date.is_valid_date (my_year, yytype3 (yyvs.item (yyvsp - 1)).item, yytype3 (yyvs.item (yyvsp - 2)).item)
			then
				my_date.make_utc_date (my_year, yytype3 (yyvs.item (yyvsp - 1)).item, yytype3 (yyvs.item (yyvsp - 2)).item)
				yyval14 := my_date
			end
		
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 70 then
--|#line 413 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 413")
end


			if my_date.is_two_digit_year (yytype3 (yyvs.item (yyvsp)).item) then
				my_year := my_date.four_digit_year (yytype3 (yyvs.item (yyvsp)).item)
			else
				my_year := yytype3 (yyvs.item (yyvsp)).item
			end
			if
				my_year >= my_date.minimum_year and then
				yytype3 (yyvs.item (yyvsp - 2)).item >= 1 and then yytype3 (yyvs.item (yyvsp - 2)).item <= 12 and then
				my_date.is_valid_day (my_year, yytype3 (yyvs.item (yyvsp - 2)).item, yytype3 (yyvs.item (yyvsp - 4)).item)
			then
				my_date.make_utc_date (my_year, yytype3 (yyvs.item (yyvsp - 2)).item, yytype3 (yyvs.item (yyvsp - 4)).item)
				yyval14 := my_date
			end
		
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp := yyvsp - 4
	yyvs.put (yyval, yyvsp)
end
when 71 then
--|#line 432 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 432")
end


			if
				yytype3 (yyvs.item (yyvsp - 1)).item >= 1 and yytype3 (yyvs.item (yyvsp)).item <= 12 and then
				my_date.is_valid_day (my_date.current_year, yytype3 (yyvs.item (yyvsp - 1)).item, yytype3 (yyvs.item (yyvsp)).item)
			then
				my_date.make_utc_date (my_date.current_year, yytype3 (yyvs.item (yyvsp - 1)).item, yytype3 (yyvs.item (yyvsp)).item)
				yyval14 := my_date
			end
		
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 72 then
--|#line 447 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 447")
end


			if yytype14 (yyvs.item (yyvsp - 2)) /= Void and then yytype14 (yyvs.item (yyvsp - 1)) /= Void then
				create yyval14.make_utc_date_time (yytype14 (yyvs.item (yyvsp - 2)).year, yytype14 (yyvs.item (yyvsp - 2)).month, yytype14 (yyvs.item (yyvsp - 2)).day, yytype14 (yyvs.item (yyvsp - 1)).hour, yytype14 (yyvs.item (yyvsp - 1)).minute, yytype14 (yyvs.item (yyvsp - 1)).second)
				minutes := yytype16 (yyvs.item (yyvsp)).item.abs \\ 100
				hours := yytype16 (yyvs.item (yyvsp)).item.abs // 100
				seconds := (minutes * 60 + hours * 3600)
				if yytype16 (yyvs.item (yyvsp)).item < 0 then
					seconds := -1 * seconds
				end
				yyval14.make_from_unix_time (yyval14.value - seconds)
				yyval14.to_utc
			end
		
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 73 then
--|#line 464 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 464")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 74 then
--|#line 465 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 465")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 75 then
--|#line 466 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 466")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 76 then
--|#line 467 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 467")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 77 then
--|#line 468 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 468")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 78 then
--|#line 469 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 469")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 79 then
--|#line 470 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 470")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 80 then
--|#line 474 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 474")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 81 then
--|#line 478 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 478")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 82 then
--|#line 480 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 480")
end


yyval2 := yytype2 (yyvs.item (yyvsp - 2)) + "." + yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 83 then
--|#line 485 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 485")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 84 then
--|#line 490 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 490")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 85 then
--|#line 495 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 495")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 86 then
--|#line 497 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 497")
end


yyval2 := yytype2 (yyvs.item (yyvsp - 2)) + "." + yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 87 then
--|#line 502 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 502")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 88 then
--|#line 506 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 506")
end


my_time.make_utc_time (yytype3 (yyvs.item (yyvsp - 3)).item, yytype3 (yyvs.item (yyvsp - 1)).item, yytype16 (yyvs.item (yyvsp)).item); yyval14 := my_time 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 89 then
--|#line 511 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 511")
end


yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 90 then
--|#line 516 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 516")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 91 then
--|#line 518 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 518")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 92 then
--|#line 528 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 528")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 93 then
--|#line 530 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 530")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 94 then
--|#line 532 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 532")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 95 then
--|#line 538 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 538")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 96 then
--|#line 544 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 544")
end


		if yytype2 (yyvs.item (yyvsp)).is_integer then
			yyval16 := yytype2 (yyvs.item (yyvsp)).to_integer
		else
			abort
		end
		
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 97 then
--|#line 555 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 555")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 98 then
--|#line 557 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 557")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 99 then
--|#line 563 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 563")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 100 then
--|#line 564 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 564")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 101 then
--|#line 568 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 568")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 102 then
--|#line 569 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 569")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 103 then
--|#line 570 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 570")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 104 then
--|#line 574 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 574")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 105 then
--|#line 581 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 581")
end


yyval2 := yytype2 (yyvs.item (yyvsp - 3)) + yytype2 (yyvs.item (yyvsp - 1)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp := yyvsp - 4
	yyvs.put (yyval, yyvsp)
end
when 106 then
--|#line 583 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 583")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 107 then
--|#line 588 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 588")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 108 then
--|#line 589 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 589")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 109 then
--|#line 593 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 593")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 110 then
--|#line 598 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 598")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 111 then
--|#line 604 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 604")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 112 then
--|#line 608 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 608")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 113 then
--|#line 609 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 609")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 114 then
--|#line 613 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 613")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 115 then
--|#line 614 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 614")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 116 then
--|#line 618 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 618")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 117 then
--|#line 622 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 622")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 118 then
--|#line 623 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 623")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 119 then
--|#line 627 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 627")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 120 then
--|#line 628 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 628")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 121 then
--|#line 632 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 632")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 122 then
--|#line 633 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 633")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 123 then
--|#line 639 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 639")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 124 then
--|#line 640 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 640")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 125 then
--|#line 641 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 641")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp := yyvsp - 3
	yyvs.put (yyval, yyvsp)
end
when 126 then
--|#line 647 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 647")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 127 then
--|#line 648 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 648")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 128 then
--|#line 652 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 652")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 129 then
--|#line 653 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 653")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 130 then
--|#line 657 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 657")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 131 then
--|#line 658 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 658")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 132 then
--|#line 662 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 662")
end


yyval16 := 0 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 133 then
--|#line 664 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 664")
end


yyval16 := yytype3 (yyvs.item (yyvsp)).item 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 134 then
--|#line 669 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 669")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 135 then
--|#line 670 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 670")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 136 then
--|#line 674 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 674")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 137 then
--|#line 675 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 675")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 138 then
--|#line 679 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 679")
end


			yytype2 (yyvs.item (yyvsp - 2)).to_lower
			create yyval15.make (yytype2 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp)))
			current_parameter_field.parameters.put (yyval15, yytype2 (yyvs.item (yyvsp - 2)))
		
			yyval := yyval15
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 139 then
--|#line 688 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 688")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 140 then
--|#line 689 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 689")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 141 then
--|#line 695 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 695")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 142 then
--|#line 696 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 696")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 143 then
--|#line 697 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 697")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 144 then
--|#line 703 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 703")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 145 then
--|#line 704 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 704")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 146 then
--|#line 705 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 705")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 147 then
--|#line 709 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 709")
end



			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 148 then
--|#line 713 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 713")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 149 then
--|#line 714 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 714")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 150 then
--|#line 718 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 718")
end

			yyval := yyval_default;
yyval := yytype2 (yyvs.item (yyvsp)) 

if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 151 then
--|#line 723 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 723")
end


yyval2  := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 152 then
--|#line 725 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 725")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 153 then
--|#line 730 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 730")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 154 then
--|#line 735 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 735")
end


yyval14 := yytype14 (yyvs.item (yyvsp)) 
			yyval := yyval14
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 155 then
--|#line 740 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 740")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 156 then
--|#line 747 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 747")
end


			if yytype2 (yyvs.item (yyvsp)).as_lower.is_equal ("multipart") then
				yyval2 := "multipart"
				part.create_multipart_body
			else
				yyval2 := yytype2 (yyvs.item (yyvsp))
			end
		
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 157 then
--|#line 759 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 759")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 158 then
--|#line 761 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 761")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 159 then
--|#line 766 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 766")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp := yyvsp - 1
	yyvs.put (yyval, yyvsp)
end
when 160 then
--|#line 767 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 767")
end

			yyval := yyval_default;


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 161 then
--|#line 771 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 771")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 162 then
--|#line 773 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 773")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 163 then
--|#line 782 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 782")
end


yyval16 := yytype3 (yyvs.item (yyvsp)).item 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 164 then
--|#line 784 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 784")
end


yyval16 := yytype3 (yyvs.item (yyvsp - 1)).item 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 165 then
--|#line 789 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 789")
end


yyval16 := 0 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 166 then
--|#line 791 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 791")
end


yyval16 := yytype16 (yyvs.item (yyvsp)) 
			yyval := yyval16
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
when 167 then
--|#line 798 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 798")
end


create yyval5.make (yytype2 (yyvs.item (yyvsp - 2)), yytype2 (yyvs.item (yyvsp))) 
			yyval := yyval5
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp := yyvsp - 2
	yyvs.put (yyval, yyvsp)
end
when 168 then
--|#line 803 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 803")
end


yyval2 := "" 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyvsp := yyvsp + 1
	if yyvsp >= yyvsc then
		yyvsc := yyvsc + yyInitial_stack_size
		yyvs := FIXED_ARRAY_.resize (yyvs, yyvsc)
		debug ("GEYACC")
			std.error.put_string ("Stack (yyvs) size increased to ")
			std.error.put_integer (yyvsc)
			std.error.put_new_line
		end
	end
	yyvs.put (yyval, yyvsp)
end
when 169 then
--|#line 805 "epx_mime_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'epx_mime_parser.y' at line 805")
end


yyval2 := yytype2 (yyvs.item (yyvsp)) 
			yyval := yyval2
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs.put (yyval, yyvsp)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 260 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,   52,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,   46,   50,   44,   43,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,   42,   45,
			   48,   51,   49,    2,   47,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41, yyDummy>>)
		end

	yyr1_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,   99,   99,  100,  100,   53,   53,   53,  101,   55,
			   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
			   55,   55,   55,   55,   55,   55,   55,  102,  102,  103,
			  103,   56,  114,   57,   58,   59,  115,   60,  116,  104,
			   61,  118,  119,   62,   63,  105,  126,  106,  108,  107,
			  109,  110,  111,  111,  129,  129,  112,  112,  112,  131,
			  131,   64,  132,  132,   65,   66,   67,   67,   67,   68,
			   69,   70,   71,  135,  135,  135,  135,  135,  135,  135,
			  136,   72,   72,   73,   74,   75,   75,  130,   76,   77,
			   78,   78,   79,   79,   79,   80,   97,   81,   81,  127,

			  127,  117,  117,  117,   82,   83,   83,  138,  138,   84,
			  133,  139,  140,  140,  141,  141,  142,  121,  121,  134,
			  134,  143,  143,  125,  125,  125,  120,  120,  124,  124,
			  137,  137,   87,   87,  122,  122,  123,  123,   85,  113,
			  113,  145,  145,  145,  128,  128,  128,   86,  146,  146,
			  147,   88,   88,   89,   90,   91,   92,   93,   93,  144,
			  144,   98,   98,   94,   94,   95,   95,   54,   96,   96, yyDummy>>)
		end

	yytypes1_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    4,    5,    4,    6,    7,    8,    9,   10,
			   11,   12,   13,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    4,    1,    1,    1,    1,    2,    2,
			    2,    2,   16,    1,    1,    2,    2,    2,    2,    2,
			    2,    2,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,

			    1,    2,    2,    2,    1,    1,    1,    1,    1,    1,
			    2,    2,   11,    1,   10,    2,    2,    2,    2,   16,
			    2,    2,    1,    1,    1,    1,    1,    1,    2,    1,
			    1,    1,    1,    1,    1,    1,    1,    2,    2,    1,
			    1,    2,    1,    2,    2,    2,    2,    2,    1,    1,
			    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
			    1,   14,   14,    1,    1,   14,    1,    6,   16,    2,
			    1,    2,    1,    1,    2,    2,    1,    1,    1,    1,
			    1,    2,    1,    1,    2,    1,    1,    1,   11,    3,
			    3,   14,   14,   14,   14,    1,    2,    2,    1,    1,

			    1,    1,    1,    2,    2,    1,    1,    1,    2,    2,
			    2,    2,    2,    1,    1,    3,    3,    3,   14,   14,
			    9,    2,   15,    2,    2,    1,    1,    1,    3,    3,
			    1,    1,    3,   16,   16,    1,    1,    1,    1,    2,
			    1,    1,    1,    3,    3,    2,    2,    2,    1,    2,
			    1,    3,    1,   16,    1,    2,    1,    3,    1,   14,
			    1,    1,    1, yyDummy>>)
		end

	yytypes2_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    2,    2,    2,    3,    3,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1, yyDummy>>)
		end

	yydefact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    8,    0,    0,    0,   11,   12,   13,   14,   15,
			   17,   18,   19,    0,    9,   10,   16,   20,   21,   22,
			   23,   24,   25,   26,  168,    0,   53,    0,    0,    0,
			    0,    0,  126,    0,   41,    0,   38,    0,    0,    0,
			    0,   30,   28,    0,    4,    6,    5,    1,  169,  167,
			   64,   96,    0,    0,   56,  162,   99,  161,   97,   84,
			    0,   80,  150,   52,   54,   57,   55,  107,   63,    0,
			  100,  147,  148,   80,   51,   49,   48,  101,   47,  102,

			   59,   98,  146,   85,   50,  116,  145,    0,  117,    0,
			  106,   43,  119,   39,  119,  156,    0,  104,   34,   33,
			  155,   32,   29,   27,    7,    0,    0,  114,    0,    0,
			    0,  112,    0,    0,  130,    0,  108,  162,  161,  149,
			    0,   60,    0,  152,   83,  121,  151,   81,    0,  134,
			  109,   90,    0,   91,   79,   78,   77,   76,   75,   74,
			   73,   89,   42,    0,    0,   37,    0,  139,   44,  115,
			   62,    0,  111,  113,   86,   61,  131,    0,   58,  103,
			  144,  122,  127,    0,  118,    0,  136,    0,  139,    0,
			    0,    0,   66,   67,   68,  120,  153,   36,  142,   31,

			  140,  110,   87,   82,  135,    0,  128,  137,   95,   92,
			    0,   94,   93,   40,    0,    0,   71,    0,  154,  165,
			  139,    0,  141,   65,  159,    0,  123,  105,    0,   69,
			    0,    0,  163,  166,   72,   35,    0,  143,  160,  129,
			    0,    0,    0,  132,    0,  158,  157,  138,    0,  124,
			   46,   70,    0,   88,  164,    0,  119,  133,  125,   45,
			    0,    0,    0, yyDummy>>)
		end

	yydefgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
			   32,   76,   77,  221,  191,  192,  193,  194,  161,  145,
			  146,   78,   79,  218,  162,  152,  210,  211,   80,  118,
			  111,  153,  222,   93,  253,  147,  197,  219,  121,  116,
			  247,  233,  234,   69,   72,   82,  260,   33,   63,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   83,
			  199,  167,  220,  114,   98,  112,  188,  108,  149,  186,
			  206,  226,  241,  256,   84,  104,   85,   86,  142,   87,
			   88,  163,  164,   89,  177,   90,  129,  130,  131,  106,
			  182,  207,  200,   91,   92, yyDummy>>)
		end

	yypact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  201, -32768,  190,  189,  188,  187,  186,  185,  184,  183,
			  182,  181,  180,  159,  154,  152,  151,  150,  147,  146,
			  141, -32768,  158,  145,  144, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,  143, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768,  142,   77,   19,   51,   51,   19,
			    6,   47,  123,   38, -32768,    6, -32768,   77,   77,   77,
			   77,   19,   19,  113, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,  137,   54, -32768,  132, -32768,    9, -32768, -32768,
			  102,  115, -32768, -32768, -32768,  112, -32768, -32768, -32768,  107,
			 -32768, -32768,   99, -32768, -32768, -32768, -32768, -32768, -32768,  110,

			   54, -32768, -32768,  106, -32768, -32768, -32768,   36,  122,   88,
			 -32768, -32768,   81, -32768,   81, -32768,  104, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,   77,   36, -32768,   97,   73,
			   -1, -32768,   77,   36,    6,   19, -32768, -32768, -32768, -32768,
			    6, -32768,   96, -32768, -32768,  121, -32768,   95,   36,  111,
			 -32768, -32768,   90, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,  100,   89, -32768,   77,   78, -32768, -32768,
			 -32768,   87, -32768, -32768, -32768, -32768, -32768,   85, -32768, -32768,
			 -32768, -32768, -32768,   36, -32768,   77,   75,   69,   78,   13,
			  109,  108, -32768, -32768, -32768, -32768, -32768, -32768,   77, -32768,

			 -32768, -32768, -32768, -32768, -32768,   77,  103, -32768, -32768, -32768,
			   82, -32768, -32768, -32768,  105,  101, -32768,   86, -32768,    8,
			   78,   76,   78, -32768,   75,   77,   70, -32768,   52, -32768,
			   68,   57, -32768, -32768, -32768, -32768,   84, -32768, -32768, -32768,
			   28,   33,   48,   27,   -8, -32768, -32768, -32768,   73, -32768,
			 -32768, -32768,   11, -32768, -32768,  -17,   81, -32768, -32768, -32768,
			   24,   21, -32768, yyDummy>>)
		end

	yypgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  -50,  -45, -32768, -32768, -32768, -32768, -32768, -112, -117,
			 -32768, -32768, -102, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,   49, -32768,  -27, -32768, -32768, -32768, -32768, -188, -32768,
			 -32768, -32768, -32768, -32768,  -54, -32768, -32768,  211, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  -23,
			 -177, -32768, -32768, -32768,  -51, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768,  -30, -32768, -32768, -32768, -32768,  148,
			  192, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  114, -32768,
			 -32768,  -24,  -35,   60, -32768, yyDummy>>)
		end

	yytable_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   71,  102,  165,  110,  113,  119,  103,  151,  103,  169,
			  223,  213,  115,  117,   71,  120,  175,   94,   95,   81,
			   99,  262,   81,  128,  261,   99,   96,   70,  103,   75,
			  174,  184,  258,  232,   81,   81,  257,  215,  122,  123,
			   70,  172,   75,  235,  254,  127,  126,  138,  246,   70,
			  141,  101,   97,  132,   73,  103,  -85,   70,  143,   70,
			  231,  101,  144,  214,  103,   74,  203,   73,   70,  252,
			  101,  168,   70,  251,   75,   70,  248,  101,  250,  171,
			   71,  144,  244,  176,  103,  209,  109,  103,  144,  179,
			   70,  208,  150,  243,   70,  100,  101,  240,   70,   73,

			  127,  126,  242,  144,   99,   70,  205,  245,   81,   70,
			   99,  150,  178,  160,  159,  158,  157,  156,  155,  154,
			   70,  196,  137,  198,  190,  189,  229,  236,  230,  228,
			  202,  227,  225,  217,  216,  195,  201,  187,  144,  183,
			  204,  185,  103,  181,  259,  180,  170,  166,  148,  133,
			  132,  107,  139,  120,  124,   73,  140,  134,  135,   21,
			  224,   20,   19,   18,   17,   16,   15,   14,   13,   12,
			   11,   10,    9,    8,    7,    6,    5,    4,    3,  -98,
			  239,  125,   68,   62,   67,   66,   65,  237,   61,   60,
			  249,  120,   59,   58,   57,  103,   56,    2,  255,   -3,

			  238,   55,   21,  103,   20,   19,   18,   17,   16,   15,
			   14,   13,   12,   11,   10,    9,    8,    7,    6,    5,
			    4,    3,   54,   53,   52,   51,   50,   49,   48,   47,
			   46,   45,   44,   64,    0,    0,  212,  136,    0,    0,
			    2,    0,    1,  105,  173, yyDummy>>)
		end

	yycheck_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   45,   51,  114,   53,   55,   59,   51,  109,   53,  126,
			  198,  188,   57,   58,   59,   60,  133,   47,   48,   46,
			   50,    0,   49,   73,    0,   55,   49,   21,   73,   23,
			  132,  148,   49,   25,   61,   62,   25,   24,   61,   62,
			   21,   42,   23,  220,   52,   46,   47,   92,  236,   21,
			  100,   23,   46,   44,   48,  100,   47,   21,   22,   21,
			   52,   23,  107,   50,  109,   46,  183,   48,   21,   42,
			   23,  125,   21,   25,   23,   21,   48,   23,   45,  129,
			  125,  126,   25,  134,  129,  187,   48,  132,  133,  140,
			   21,   22,   23,   25,   21,   48,   23,   27,   21,   48,

			   46,   47,   50,  148,  134,   21,   31,   23,  135,   21,
			  140,   23,  135,   32,   33,   34,   35,   36,   37,   38,
			   21,  166,   23,   45,   24,   25,   25,   51,   42,   24,
			   45,   49,   29,   25,   25,   46,   49,   47,  183,   44,
			  185,   30,  187,   22,  256,   49,   49,   43,   26,   47,
			   44,   28,   92,  198,   41,   48,   46,   42,   46,    1,
			  205,    3,    4,    5,    6,    7,    8,    9,   10,   11,
			   12,   13,   14,   15,   16,   17,   18,   19,   20,   47,
			  225,   44,   40,   42,   41,   41,   41,  222,   42,   42,
			  240,  236,   42,   42,   42,  240,   42,   39,  248,   41,

			  224,   42,    1,  248,    3,    4,    5,    6,    7,    8,
			    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
			   19,   20,   42,   42,   42,   42,   42,   42,   42,   42,
			   42,   42,   42,   22,   -1,   -1,  187,   89,   -1,   -1,
			   39,   -1,   41,   51,  130, yyDummy>>)
		end

feature {NONE} -- Conversion

	yytype2 (v: ANY): STRING is
		require
			valid_type: yyis_type2 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type2 (v: ANY): BOOLEAN is
		local
			u: STRING
		do
			u ?= v
			Result := (u = v)
		end

	yytype3 (v: ANY): INTEGER_REF is
		require
			valid_type: yyis_type3 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type3 (v: ANY): BOOLEAN is
		local
			u: INTEGER_REF
		do
			u ?= v
			Result := (u = v)
		end

	yytype4 (v: ANY): EPX_MIME_FIELD is
		require
			valid_type: yyis_type4 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type4 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD
		do
			u ?= v
			Result := (u = v)
		end

	yytype5 (v: ANY): EPX_MIME_UNSTRUCTURED_FIELD is
		require
			valid_type: yyis_type5 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type5 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_UNSTRUCTURED_FIELD
		do
			u ?= v
			Result := (u = v)
		end

	yytype6 (v: ANY): EPX_MIME_FIELD_CONTENT_DISPOSITION is
		require
			valid_type: yyis_type6 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type6 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_DISPOSITION
		do
			u ?= v
			Result := (u = v)
		end

	yytype7 (v: ANY): EPX_MIME_FIELD_CONTENT_LENGTH is
		require
			valid_type: yyis_type7 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type7 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_LENGTH
		do
			u ?= v
			Result := (u = v)
		end

	yytype8 (v: ANY): EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING is
		require
			valid_type: yyis_type8 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type8 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING
		do
			u ?= v
			Result := (u = v)
		end

	yytype9 (v: ANY): EPX_MIME_FIELD_CONTENT_TYPE is
		require
			valid_type: yyis_type9 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type9 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_CONTENT_TYPE
		do
			u ?= v
			Result := (u = v)
		end

	yytype10 (v: ANY): EPX_MIME_FIELD_DATE is
		require
			valid_type: yyis_type10 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type10 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_DATE
		do
			u ?= v
			Result := (u = v)
		end

	yytype11 (v: ANY): EPX_MIME_FIELD_IF_MODIFIED_SINCE is
		require
			valid_type: yyis_type11 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type11 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_IF_MODIFIED_SINCE
		do
			u ?= v
			Result := (u = v)
		end

	yytype12 (v: ANY): EPX_MIME_FIELD_MESSAGE_ID is
		require
			valid_type: yyis_type12 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type12 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_MESSAGE_ID
		do
			u ?= v
			Result := (u = v)
		end

	yytype13 (v: ANY): EPX_MIME_FIELD_MIME_VERSION is
		require
			valid_type: yyis_type13 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type13 (v: ANY): BOOLEAN is
		local
			u: EPX_MIME_FIELD_MIME_VERSION
		do
			u ?= v
			Result := (u = v)
		end

	yytype14 (v: ANY): STDC_TIME is
		require
			valid_type: yyis_type14 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type14 (v: ANY): BOOLEAN is
		local
			u: STDC_TIME
		do
			u ?= v
			Result := (u = v)
		end

	yytype16 (v: ANY): INTEGER is
		require
			valid_type: yyis_type16 (v)
		local
			ref: INTEGER_REF
		do
			ref ?= v
			Result := ref.item
		end

	yyis_type16 (v: ANY): BOOLEAN is
		local
			u: INTEGER_REF
		do
			u ?= v
			Result := (u = v)
		end


feature {NONE} -- Constants

	yyFinal: INTEGER is 262
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 53
			-- Number of tokens

	yyLast: INTEGER is 244
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 296
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 148
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features




feature -- Initialization

	make is
		do
			if last_line = Void then
				make_scanner
				precursor
				create last_line.make (128)
			end
			level := 1
			boundary := Void
			create my_date.make_from_now
			my_date.to_utc
			create my_time.make_from_now
			my_time.to_utc
		end

	make_from_file (a_file: STDC_TEXT_FILE) is
			-- Like `make_from_stream', but turns off buffering in
			-- `a_file'.
		require
			file_not_void: a_file /= Void
			file_open: a_file.is_open
		do
			a_file.set_no_buffering
			make_from_stream (a_file)
		end

	make_from_stream (a_stream: EPX_CHARACTER_INPUT_STREAM) is
		require
			stream_not_void: a_stream /= Void
			stream_open: a_stream.is_open_read
		do
			make
			set_input_buffer (new_mime_request_buffer (a_stream))
		end

	make_from_file_descriptor (a_fd: ABSTRACT_FILE_DESCRIPTOR) is
		obsolete "Use make_from_stream instead."
		do
			make_from_stream (a_fd)
		end


feature -- Character reading

	eof: BOOLEAN is
			-- True if `read_character' hits end-of-file.
		do
			Result :=
				last_character = yyEnd_of_file_character and
				not input_buffer.filled
		end


feature {NONE} -- Scanning

	regular_buffer: like input_buffer
			-- Cache of `input_buffer', to be copied back on `wrap'.

	wrap: BOOLEAN is
			-- Check if we were parsing header, if so, resume with main
			-- buffer.
		do
			if regular_buffer /= Void then
				set_input_buffer (regular_buffer)
				regular_buffer := Void
			else
				Result := True
			end
		ensure then
			regular_buffer_void: regular_buffer = Void
		end


feature {NONE} -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			Result := mime_tokens.token_name (a_token)
		end


feature -- Parsing

	reset_parsing_errors is
			-- Reset count of parsing errors.
		do
			parsing_errors := 0
			accept
		ensure
			no_parsing_errors: parsing_errors = 0
		end

	parse is
			-- Read input and build `part'.
			-- Check `syntax_error' for parsing errors.
		do
			create part.make_empty
			parsing_errors := 0
			inner_parse
		end

	parse_body (a_content_length: INTEGER) is
			-- Parse MIME body.
			-- Assume `input_buffer' points to body part.
			-- If `a_content_length' positive, scans only as much body as
			-- given by `a_content_length', given that the input buffer
			-- is an EPX_MIME_BUFFER.
		require
			header_parsed: part /= Void
			content_length_not_negative: a_content_length >= 0
			part_not_void: part /= Void
		local
			buf: EPX_MIME_BUFFER
			is_multipart_body: BOOLEAN
			multipart_body: EPX_MIME_BODY_MULTIPART
			save_part: EPX_MIME_PART
			save_boundary: STRING
		do
			if a_content_length > 0 then
				buf ?= input_buffer
				if buf /= Void then
					buf.set_end_of_file_on_content_length (a_content_length, yy_end)
				end
			end

			-- Be very careful in determining if we should parse a
			-- multipart body.
			is_multipart_body :=
				part.body /= Void and then part.body.is_multipart and then
				part.header.content_type /= Void and then part.header.content_type.parameters.has (parameter_name_boundary)
			if is_multipart_body then
				part.header.content_type.parameters.search (parameter_name_boundary)
				is_multipart_body := part.header.content_type.parameters.found
				if is_multipart_body then
					save_boundary := boundary
					boundary := "--" + part.header.content_type.parameters.found_item.value
					is_multipart_body := boundary.count <= Max_rfc_2046_boundary_length + 2
				end
			end

			if is_multipart_body then
				-- Some overflow test here in `level'?
				level := level + 1
				save_part := part
				multipart_body ?= save_part.body
				forward_to_boundary
				-- Because we call ourselves recursively, we have to be
				-- very careful that state is correctly saved. That I have
				-- to put a comment here, already indicates that this is
				-- fragile, and probably has to be rewritten.
				from
				until
					end_of_file or else
					eof or else
					boundary_with_trailer_read
				loop
					part := multipart_body.new_part
					inner_parse
				end
				boundary_with_trailer_read := False
				level := level - 1
				part := save_part
				if save_boundary /= Void and then boundary /= save_boundary then
					-- boundary changed (multipart in multipart), move
					-- forward to boundary, that's the end of the multipart
					-- in side the multipart.
					boundary := save_boundary
					forward_to_boundary
				end
			else
				-- We get here to read a body which ends with eof or
				-- a mime boundary. Make sure we have a single part body.
				part.clear_body
				part.create_singlepart_body
				read_singlepart_body (part.header.content_transfer_encoding)
			end

		end

	parse_header is
			-- Read just the MIME header from the input and build a new
			-- `part'.  Check `syntax_error' for parsing errors.
		local
			buf: EPX_MIME_BUFFER
		do
			buf ?= input_buffer
			if buf /= Void then
				buf.set_end_of_file_on_end_of_header (True)
			end
			create part.make_empty
			reset_parsing_errors
			set_start_condition (INITIAL)
			do_parse
		end

	set_header (a_header: STRING) is
			-- Optional header that is parsed before the regular input
			-- is parsed.
		require
			a_header_not_empty: a_header /= Void and then not a_header.is_empty
		local
			string_buffer: YY_BUFFER
		do
			regular_buffer := input_buffer
			create string_buffer.make (a_header)
			set_input_buffer (string_buffer)
		end

	parsing_errors: INTEGER
			-- Number of errors encountered when parsing.


feature {NONE} -- Parse

	inner_parse is
			-- Read input and build `part'.
			-- To be called from inside `parse_body'.
		require
			part_not_void: part /= Void
		do
			set_start_condition (INITIAL)
			do_parse
			parse_body (0)
		end


feature {NONE} -- Error reporting

	report_error (a_message: STRING) is
			-- Dump error to stderr. Needs to be rewritten.
		do
			debug ("mime")
				std.error.put_string ("line ")
				std.error.put_integer (line)
				std.error.put_string (", ")
				std.error.put_integer (column)
				std.error.put_string (": ")
				std.error.put_string (a_message)
				std.error.put_character ('%N')
				std.error.put_string ("  text: %"")
				if last_value /= Void then
					std.error.put_string (last_value.out)
				end
				std.error.put_string ("%" (")
				std.error.put_string (text)
				std.error.put_string (")%N")
				std.error.put_string ("  token: ")
				std.error.put_integer (last_token)
				std.error.put_character ('%N')

				--exit_with_failure
				exceptions.raise ("problem")
			end
			parsing_errors := parsing_errors + 1
		end


feature -- State

	part: EPX_MIME_PART
			-- Structure we're building.


feature {NONE} -- State used during parsing

	seconds,
	minutes,
	hours: INTEGER

	level: INTEGER

	my_content_disposition: EPX_MIME_FIELD_CONTENT_DISPOSITION

	my_content_type: EPX_MIME_FIELD_CONTENT_TYPE

	my_if_modified_since: EPX_MIME_FIELD_IF_MODIFIED_SINCE

	my_date: STDC_TIME

	my_time: STDC_TIME

	my_year: INTEGER

	current_parameter_field: EPX_MIME_FIELD_WITH_PARAMETERS


feature {NONE} -- Reading mime bodies

	boundary: STRING
			-- For multipart MIME messages, it designates the end of a body.

	boundary_with_trailer_read: BOOLEAN

	determine_boundary_with_trailer_read is
			-- There was a boundary match, determine if two dashes follow
			-- (last boundary) and set `boundary_with_trailer_read' in that case.
		do
			-- NOTE: we've already read one character.
			boundary_with_trailer_read := last_character = '-'
			if boundary_with_trailer_read then
				read_character
				boundary_with_trailer_read := last_character = '-'
			end
		end

	forward_to_boundary is
			-- Move input cursor to line that contains `boundary'.
			-- Assume we start reading at beginning of a line.
		require
			boundary_not_empty: boundary /= Void and then not boundary.is_empty
		local
			boundary_read: BOOLEAN
			matching_boundary: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
		do
			from
				matching_boundary := True
				matched_index := 1
				read_character
			until
				eof or else
				boundary_read
			loop
				if last_character = '%N' then
					-- Start matching beginning of boundary
					matching_boundary := True
					matched_index := 1
				else
					if matching_boundary then
						match := boundary.item (matched_index) = last_character
						if match then
							-- Match found, advance to next character.
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							matching_boundary := False
						end
					end
				end
				read_character
			end

			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line
		end

	forward_to_end_of_line is
			-- Always move cursor to next line.
		do
			from
			until
				eof or else
				last_character = '%N'
			loop
				read_character
			end
		ensure
			cursor_at_new_line: eof or else last_character = '%N'
		end

	is_text_body: BOOLEAN is
			-- Contains part.body text?
		local
			text_body: EPX_MIME_BODY_TEXT
		do
			text_body ?= part.body
			Result := text_body /= Void
		end

	last_line: STRING
			-- We store last read line here when reading multipart bodies

	Max_rfc_2046_boundary_length: INTEGER is 70
			-- Max length of a boundary according to RFC 2046

	read_singlepart_body (encoding: EPX_MIME_FIELD_CONTENT_TRANSFER_ENCODING) is
			-- Read from input until end of file is reached or a line
			-- contains `boundary'.
		require
			body_not_void: part.body /= Void
			body_is_single_part: not part.body.is_multipart
		local
			body: EPX_MIME_BODY_TEXT
		do
			if boundary = Void then
				read_singlepart_body_without_boundary
			else
				read_singlepart_body_with_boundary
			end
			if encoding /= Void then
				body ?= part.body
				if body /= Void then
					body.set_decoder (encoding.new_decoder)
				end
			end
		end

	read_singlepart_body_with_boundary is
			-- Start reading a single part. This routine has to do two
			-- things right: it has to stop when a boundary has been
			-- parsed, and the cr+lf before the boundary is not part of
			-- the file.
		require
			boundary_is_set: boundary /= Void
			has_buffer: last_line /= Void
			body_contains_text: is_text_body
		local
			boundary_read: BOOLEAN
			matched_index: INTEGER
			match: BOOLEAN
			c: CHARACTER
			matching_boundary: BOOLEAN
			body: EPX_MIME_BODY_TEXT
			add_cr: BOOLEAN
		do
			body ?= part.body
			-- This loop reads data character by character.
			-- We have to stop when a boundary occurs after a CRLF.
			from
				matching_boundary := True
				last_line.wipe_out
				matched_index := 1
				read_character
			invariant
				matched_index >= 1
				not boundary_read implies matched_index <= boundary.count
				matching_boundary implies matched_index <= last_line.count + 1
			until
				eof or else
				boundary_read
			loop

				-- `c' contains the current character
				c := last_character

				inspect c
				when '%R' then
					-- when a CR is encountered, we've to check for a LF to
					-- know if this is an end of line or an incidental CR
					-- (pure data)
					last_line.append_character (c)
				when '%N' then
					-- the next line could contain the boundary so we don't
					-- write the (CR)LF, but keep it in `last_line'. The
					-- CRLF is part of the boundary in that case, not of
					-- the message.
					if last_line.count > 0 and then
						last_line.item (last_line.count) = '%R' then
						-- at this point a CRLF has been read
						last_line.remove (last_line.count)
						add_cr := True
					else
						add_cr := False
					end
					body.append_string (last_line)
					last_line.wipe_out
					if add_cr then
						last_line.append_character ('%R')
					end
					last_line.append_character (c)
					matched_index := 1
					matching_boundary := True
				else
					if matching_boundary then
						match := boundary.item (matched_index) = c
						if match then
							-- Match found, advance to next character.
							last_line.append_character (c)
							matched_index := matched_index + 1
							boundary_read := matched_index > boundary.count
						else
							-- Mismatch. As boundary has to match only at
							-- beginning of line, we just have a data line.
							body.append_string (last_line)
							body.append_character (c)
							last_line.wipe_out
							matching_boundary := False
						end
					else
						body.append_string (last_line)
						body.append_character (c)
						last_line.wipe_out
					end
				end

				-- very expensive check
					check
						-- last_line.has_substring (boundary) implies boundary_read
					end

				read_character
			end

			-- if boundary read, skip rest of line
			if boundary_read then
				determine_boundary_with_trailer_read
			end
			forward_to_end_of_line

				check
					stop_condition: boundary_read or eof
				end
		end

	read_singlepart_body_without_boundary is
			-- Read `file' until `end_of_file'. Does handle any line length.
		require
			body_contains_text: is_text_body
		local
			body: EPX_MIME_BODY_TEXT
		do
			body ?= part.body
			from
				read_character
			until
				eof
			loop
				body.append_character (last_character)
				read_character
			end
		ensure
			read_everything: eof
		end


invariant

	last_line_not_void: last_line /= Void
	my_date_not_void: my_date /= Void
	my_date_in_utc: my_date.is_utc_time
	my_time_not_void: my_time /= Void
	my_time_in_utc: my_time.is_utc_time

end
