indexing

	description: "ISE routines to access its garbage collector."

	date: "$Date: 2003/11/29 $"
	revision: "$Revision: #2 $"


class

	EPX_ISE_GC_HELPER


feature -- Unfreezing

	unfreeze_objects is
			-- Unfreeze the objects in `frozen_objects'.
		local
			i: INTEGER
		do
			from
				frozen_objects.start
			until
				frozen_objects.after
			loop
				frozen_objects.item_for_iteration.deallocate
				frozen_objects.forth
			end
			frozen_objects.wipe_out
		ensure
			all_unfrozen: frozen_objects.is_empty
		end


feature {NONE} -- ISE routines for freezing/unfreezing objects

-- 	eif_freeze (obj: ANY): POINTER is
-- 			-- Make sure that `obj' will not be moved by GC.
-- 		require
-- 			garbage_collector_enabled: memory.collecting
-- 			obj_not_void: obj /= Void
-- 		external
-- 			"C [macro <eif_eiffel.h>] (EIF_OBJECT): EIF_REFERENCE"
-- 		alias
-- 			"eif_freeze"
-- 		end

-- 	eif_unfreeze (ptr: POINTER) is
-- 			-- Object at address `ptr' can be handled
-- 			-- and moved by the GC now.
-- 		require
-- 			garbage_collector_enabled: memory.collecting
-- 			ptr_not_null: ptr /= default_pointer
-- 		external
-- 			"C [macro <eif_eiffel.h>] (EIF_REFERENCE)"
-- 		alias
-- 			"eif_unfreeze"
-- 		end

-- 	memory: expanded MEMORY


feature {NONE} -- Frozen object remembering

	frozen_objects: DS_LINKED_LIST [STDC_BUFFER] is
			-- All frozen objects are stored in this buffer. Call
			-- `clear_frozen_objects' to free them.
			-- This list of objects is shared among all external
			-- helpers. Calling `clear_frozen_objects' on any of them, will
			-- unfreeze all frozen objects.
		once
			create Result.make
		ensure
			frozen_objects_not_void: frozen_objects /= Void
			no_nil_pointers: True -- for_each o in frozen_objects (lower..highest_frozen_object) it_holds o /= default_pointer
		end

-- 	highest_frozen_object: INTEGER_REF is
-- 			-- Index in `frozen_objects', to be used by `store_pointer'.
-- 		once
-- 			create Result
-- 		ensure
-- 			highest_frozen_object.item >= frozen_objects.lower -1 and then
-- 			highest_frozen_object.item <= frozen_objects.upper
-- 		end

-- 	store_frozen_object (p: POINTER) is
-- 			-- Cache pointer in `frozen_objects'
-- 		require
-- 			p_not_null: p /= default_pointer
-- 			garbage_collector_enabled: memory.collecting
-- 		do
-- 			highest_frozen_object.set_item (highest_frozen_object.item + 1)
-- 			frozen_objects.force (p, highest_frozen_object.item)
-- 		ensure then
-- 			pointer_stored: frozen_objects.item (highest_frozen_object.item) = p
-- 			object_stored: highest_frozen_object.item = old highest_frozen_object.item + 1
-- 		end


end
